(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
    Image tournant autour du centre de l'cran. Fonction ralise avec plu- 
 sieurs procdures diffrentes de vitesse croissante.                       
Ĵ
  Fichier ncessaire                                                      
                                                      
                                                                            
 -> 'LouisAtq.Pcx': Image au format PCX v5.0 en 100x100 pixels en 256 coul. 
*)

{$N+ : Utilise le coprocesseur arithmtique }

{$M 4096,0,100000}

{-$DEFINE Fps}      { Affiche le nombre d'image / seconde }

uses Clavier,EcranVga,FaitPaus,PalVideo,Pcx,SonHP {$IFDEF Fps} ,Fps {$ENDIF};

type
  UnSprite = array[0..100*100-1] of byte;
  PtrSprite = ^UnSprite;

var
  Sprite : PtrSprite;
  TamponEcran: PtrImage;

  TableCos,TableSin : Array [0..359] of single;

  i,ix,iy, angle,
  index: Word;
  vram,vramY: LongInt;

  CoulBlanc: byte;

procedure DessineRotation_lent; var AngleR: real; begin
  AngleR := angle*PI/180;

  index := 0;
  for iy := 0 to 99 do begin
    for ix := 0 to 99 do begin
      vram := 100*320 +160 +
             Round( Sin(AngleR)*ix + Cos(AngleR)*iy )*320+
             Round( Cos(AngleR)*ix - Sin(AngleR)*iy );

      if (-1<vram) and (vram<64000) then TamponEcran^[vram] := Sprite^[index +ix];
    end;

    inc(index,100);
  end;
end;

procedure DessineRotation_table; begin
  index := 0;
  for iy := 0 to 99 do begin
    for ix := 0 to 99 do begin
      vram := 100*320 +160 +
             Round( TableSin[Angle]*ix + TableCos[Angle]*iy )*320+
             Round( TableCos[Angle]*ix - TableSin[Angle]*iy );

      if (-1<vram) and (vram<64000) then TamponEcran^[vram] := Sprite^[index +ix];
    end;

    inc(index,100);
  end;
end;

procedure DessineRotation; begin
  index := 0;
  for iy := 0 to 99 do begin
    VramY := Round(TableCos[Angle]*iy); VramY := VramY shl 8 + VramY shl 6;
    Dec(VramY,Round(TableSin[Angle]*iy));
    vramY := vramY +100*320 +160;

    for ix := 0 to 99 do begin
      vram := Round( TableSin[Angle]*ix );
      vram := Vram shl 8 + vram shl 6 +VramY +Round( TableCos[Angle]*ix );

      if (-1<vram) and (vram<64000) then TamponEcran^[vram] := Sprite^[index];

      inc (index);
    end;
  end;
end;

procedure PreCalcul; begin
  for i := 0 to 359 do begin
    TableCos [i] := Cos(i * PI/180);
    TableSin [i] := Sin(i * PI/180);
  end;
end;

Begin
  { Alloue de la mmoire }
  if MemAvail < 64000+SizeOf(UnSprite) then begin
    ModeTxt;
    Writeln ('Pas assez de mmoire libre pour cre un double buffer !');
    Writeln ('(manque ',(64000+SizeOf(UnSprite)) - MemAvail,' octets)');
    Halt (8);
  end;
  GetMem (TamponEcran,64000);
  ChangeDestEcran (TamponEcran);

  GetMem (Sprite,SizeOf(UnSprite));

  PreCalcul;
  ModeVga256; ChargePcx (Sprite,'LouisAtq'); CoulBlanc := CouleurBlanche;
  {$IFDEF Fps} InitFps (0,0,TRUE); {$ENDIF}

  angle := 0;
  repeat
    EffacePtr (TamponEcran,0);

    DessineRotation_lent;

    EcriTsp (-1,191,'sans table prcalcule',CoulBlanc);

    if angle=359 then angle := 0 else inc(angle);

    {$IFDEF Fps} ActuFps; {$ELSE} AttendEcran; {$ENDIF}
    AfficheEcran;
  until TouchPresse; LitTouche;

  {$IFDEF Fps} ReinitFps; {$ENDIF}
  repeat
    EffacePtr (TamponEcran,0);

    DessineRotation_table;

    EcriTsp (-1,191,'AVEC table',CoulBlanc);

    if angle=359 then angle := 0 else inc(angle);

    {$IFDEF Fps} ActuFps; {$ELSE} AttendEcran; {$ENDIF}
    AfficheEcran;
  until TouchPresse; LitTouche;

  {$IFDEF Fps} ReinitFps; {$ENDIF}
  repeat
    EffacePtr (TamponEcran,0);

    DessineRotation;

    EcriTsp (-1,191,'table + optimisation',CoulBlanc);

    if angle=359 then angle := 0 else inc(angle);

    {$IFDEF Fps} ActuFps; {$ELSE} AttendEcran; {$ENDIF}
    AfficheEcran;
  until TouchPresse;

  ModeTxt;
  FreeMem (TamponEcran,$FFFF);
  FreeMem (Sprite,SizeOf(UnSprite));
  {$IFDEF Fps} FinFps {$ENDIF}
End.